/*********************************************************************
Work Function Algorithm
Yongsheng Bai 03/12/04
**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INIT (-1)

//for easy check purpose, assuming the weight for each character: a=1, b=10, c=100, d=1000, e=10000 
//in order to abtain the unique identification for each configuration
#define weight_abc 111
#define weight_abd 1011
#define weight_abe 10011
#define weight_acd 1101
#define weight_ace 10101
#define weight_ade 11001
#define weight_bcd 1110
#define weight_bce 10110
#define weight_bde 11010
#define weight_cde 11100

char s[101];//array to store input sequence
int num_server, num_node;
int num_config;
int s_length;
char c[101][51];//array to print each configuration

char config[] = "abc abd abe acd ace ade bcd bce bde cde";//sample configuration
int *column_num;//save column number
char *tokenPtr;
int **Array;//2-d array to store work function values 

void update (int, int);
int check(char, char, char);
void dynamic_find(int, int);
int distance(char, char);
int fact(int);
int Select_K_From_N (int, int);


//distance between two characters
int distance(char j1, char j2)
{
  if ((j1 == 'a' && j2 == 'e') ||  (j1 == 'b' && j2 == 'e') || (j1 == 'c' && j2 == 'e') ||(j1 == 'd' && j2 == 'e')
	  || (j1 == 'e' && j2 == 'a') || (j1 == 'e' && j2 == 'b')|| (j1 == 'e' && j2 == 'c')|| (j1 == 'e' && j2 == 'd'))
	  return 2;
  else
	  return 1;
}

//function to check which column should be traced or used for calculating the current row' wfv
int check(char i1, char i2, char i3)
{
  int sum;
  sum=0;

  //printf("start the 1st check!\n");

  if (i1=='a' )
    sum = sum + 1;
  else if (i1=='b' )
    sum = sum + 10;
  else if (i1=='c' )
    sum = sum + 100;
  else if (i1=='d' )
    sum = sum + 1000;
  else 
    sum = sum + 10000;

  //printf("start the 2nd check!\n");

  if (i2=='a')
    sum = sum + 1;
  else if (i2=='b')
    sum = sum + 10;
  else if (i2=='c')
    sum = sum + 100;
  else if (i2=='d' )
    sum = sum + 1000;
  else 
    sum = sum + 10000;

  //printf("start the 3rd check!\n");

  if (i3=='a')
    sum = sum + 1;
  else if (i3=='b')
    sum = sum + 10;
  else if (i3=='c')
    sum = sum + 100;
  else if (i3=='d')
    sum = sum + 1000;
  else 
    sum = sum + 10000;

  return sum;

}

//function to find the minimum value among several candidate values
void dynamic_find(int position_p, int position_q)
{
  int temp1, temp2, temp3;
  int return_column1, return_column2, return_column3;
  
  
  return_column1 = check(s[position_p], config[4*position_q], config[4*position_q +1]);
	  temp1 = Array[position_p - 1][column_num[return_column1]] + distance(s[position_p], config[4*position_q +2]);
  return_column2 = check(s[position_p], config[4*position_q +1], config[4*position_q +2]);
	  temp2 = Array[position_p - 1][column_num[return_column2]] + distance(s[position_p], config[4*position_q]);
  return_column3 = check(s[position_p], config[4*position_q], config[4*position_q +2]);
	  temp3 = Array[position_p - 1][column_num[return_column3]] + distance(s[position_p], config[4*position_q +1]);

  //take the minimum
  if (temp1 <= temp2)
  {
	  
      if(temp3<=temp1)
		Array[position_p][position_q]=temp3;
	  else
		Array[position_p][position_q]=temp1;
  }
  else
  {
	  if (temp2 > temp3)
		Array[position_p][position_q]=temp3;
	  else
		Array[position_p][position_q]=temp2;
  }
}

//funcation update the wfv table
void update (int row_length, int col_length)
{
  int p, q,t;
  
  //update the matrix values
  for (p=1; p<row_length; p++)
  {
    t=0;
	for(q=0; q<col_length; q++)
	{
	  if (s[p] == config[q +3*t] || s[p] == config[q+ 3*t + 1] || s[p] == config[q+ 3*t + 2])
		Array[p][q] = Array[p-1][q];
	  else
	    dynamic_find(p, q);
		//printf("need update!\n");
	  t++;

	}
  }	  
}

//funcation to calculate the factorial value of n
int fact(int n)
{
  int f = 1;
  while (n>=1)
  {
    f=f*n;
    n=n-1;
  }
  return f;
} 

//function to calculate the combinatorial value for c(k,n)
int Select_K_From_N (int n, int k)
{
  int p=k;
  int c=1;
  if((k>n) || (k<=0))
    return 0;
  while(k>=1)
  {
    c=c*n;
    n=n-1;
    k=k-1;
  }
  return c/fact(p);
}
 
main ()
{
int i, j, m;

scanf("%d", &num_node);
scanf("%d", &num_server);
num_config = Select_K_From_N (num_node, num_server);

scanf("%s", s);
s_length=strlen(s);

Array = (int **)malloc((s_length) * sizeof(int *));
for (i = 0; i < (s_length); ++i)
  Array[i] = (int *) malloc(num_config * sizeof(int));
for (i=0; i<s_length; i++)
  for (j=0; j<num_config; j++)
    Array[i][j] = INIT;

column_num = (int *) malloc(100000 * sizeof(int));
for(j=0; j<100000; j++)
  column_num[j]= INIT;

printf("\n===========================\n");
printf("After initializing the wfv table:\n");

tokenPtr = strtok(config, " ");
m=0;
printf("   ");
while (tokenPtr != NULL)
{
  strcpy(c[m],tokenPtr);
  printf("%s  ", c[m]);
  m++;
  tokenPtr=strtok(NULL, " ");
}

printf("\n");

//initialize all values of initial work functions (empty request sequence)
Array[0][0]=0;
Array[0][1]=1;
Array[0][2]=2;
Array[0][3]=1;
Array[0][4]=2;
Array[0][5]=3;
Array[0][6]=1;
Array[0][7]=2;
Array[0][8]=3;
Array[0][9]=3;

for (i=0; i<s_length; i++)
{
  printf("%c", s[i]);
  for (j=0; j<num_config; j++)
  {	
    printf("%5d", Array[i][j]);   
  }
  printf("\n");
}
    
//remember the column index
column_num[weight_abc]=0; 
column_num[weight_abd]=1;
column_num[weight_abe]=2;
column_num[weight_acd]=3;
column_num[weight_ace]=4;
column_num[weight_ade]=5;
column_num[weight_bcd]=6;
column_num[weight_bce]=7;
column_num[weight_bde]=8; 
column_num[weight_cde]=9;

update(s_length, num_config);

printf("\n=========================\n");
printf("print updating results!\n");

//print updating results
for (i=0; i<s_length; i++)
{
  printf("%c", s[i]);
  for (j=0; j<num_config; j++)
  {	
    printf("%5d", Array[i][j]);   
  }
  printf("\n");
}

for(i = 0; i<(s_length); ++i)
  free(Array[i]);
free(Array);
free(column_num);

}//main
